       ;Directory Catalogue Program Mindex
 ;<c>1983 by Mel Patrick
 ;Works on NewDos 80, and Dos+ 3.4
 	ORG	6000H		;normal origin
 MINDEX	LD	DE,PBUFF	;point to buffer
 	LD	A,(3000H)	;test Model I or III
 	CP	0C3H		;JP=Model III
 	JR	NZ,MOD1		;go if Model I
 	LD	HL,(4411H)	;else get top memory
 	JR	CLR		;and clear to it
 MOD1	LD	HL,(4049H)	;get M1 top memory
 CLR	LD	(MEMSZ),HL	;save top of memory
 	SBC	HL,DE		;find memory size
 	PUSH	HL		;save size for now
 	LD	DE,16		;length of each file
 	LD	BC,0000H	;set counter to zero
 FNDMAX	OR	A		;clear any flags
 	SBC	HL,DE		;count the number of 16's
 	JR	C,DONE		;go if done
 	INC	BC		;else add 1 to count
 	JR	FNDMAX		;loop til done
 DONE	LD	(MAXINP),BC	;save number of entries
 	POP	BC		;BC=memory size avail.
 	LD	HL,PBUFF	;point to start of buffer
 	LD	(POS),HL	;save starting position
 CLRLP	LD	(HL),00H	;set memory to zero
 	INC	HL		;point to next
 	DEC	BC		;minus one from count
 	LD	A,B		;test for zero
 	OR	C		;0=done
 	JR	NZ,CLRLP	;loop til zero
 	LD	HL,(4031H)	;get normal vector
 	LD	(VECT2),HL	;save it for patch
 	CALL	RDCON		;read configuration
 	CALL	DOSSYS		;config system after read
 	CALL	DOSDIR		;config read drive
 MENU	CALL	01C9H		;clear the video
 	LD	HL,(MAXINP)	;get maximum input
 	LD	DE,(ENTRY)	;get number entered
 	SBC	HL,DE		;move answer to HL
 	LD	DE,MAXBUF	;point to buffer
 	CALL	MATH		;and convert to ASCII
 	LD	HL,(ENTRY)	;get number of entries
 	LD	DE,ENTBUF	;point to buffer
 	CALL	MATH		;convert to ASCII
 	LD	HL,(POS)	;get top of file
 	LD	DE,PBUFF	;get start of file
 	SBC	HL,DE		;find the answer
 	LD	DE,MEMBUF	;point to buffer
 	CALL	MATH		;convert to ASCII
 	LD	HL,MENU1	;point to menu
 	CALL	DISPLY		;show it on the video
 INP	CALL	49H		;wait for a key
 	CP	'0'		;look for drive number
 	JR	C,INP		;back if too low
 	CP	'4'		;else look top limit
 	JR	NC,INP1		;continue if higher
 	JP	SHODIR		;else show directory
 INP1	AND	5FH		;convert to upper case
 	CP	'B'		;want to build an index?
 	JR	Z,BUILD		;go if yes
 	CP	'E'		;else return to Dos
 	JP	Z,402DH		;Dos if yes
 	CP	'V'		;view filenames?
 	JP	Z,VIEW		;go if yes
 	CP	'P'		;send names to PRINTER?
 	JP	Z,PRINT		;go if yes
 	CP	'S'		;want a sort?
 	JP	Z,SORT		;go if yes
 	CP	'W'		;write index to DISK?
 	JP	Z,WRITE		;go if yes
 	CP	'L'		;want to LOAD an index?
 	JP	Z,LOAD		;go if yes
 	CP	'K'		;want to do a KILL?
 	JP	Z,KILL		;go if yes
 	CP	'C'		;configure system
 	JP	Z,CONFIG	;go if yes
 	JR	INP		;else get another
 BUILD	LD	HL,(ENTRY)	;get number entries
 	LD	DE,(MAXINP)	;get total number
 	RST	18H		;compare them
 	JR	Z,MENU		;back if full
 	CALL	01C9H		;clear the video
 	LD	HL,MENU2	;point to second set
 	CALL	DISPLY		;show it
 REP	LD	HL,DISKNM	;point to prompt
 	CALL	DISPLY		;show it
 	LD	HL,BUFF		;point to buffer
 	LD	B,04H		;maximum number input
 	CALL	40H		;get input
 	JP	C,RESPAT	;reset patch and menu
 	LD	A,00H		;test for just enter
 	OR	B		;0=no input
 	JR	Z,REP		;do it again if none
 	CALL	CHKDUP		;check for same name
 	LD	B,4		;bytes to move
 	LD	HL,BUFF		;point to file ID
 	LD	DE,IDBLK	;where to move it to
 BUILD1	LD	A,(HL)		;get a byte
 	CP	0DH		;look for enter
 	JR	Z,BUILD2	;space out remainder
 	LD	(DE),A		;else move to reference
 	INC	HL		;point to next
 	INC	DE		;and here
 	DJNZ	BUILD1		;loop for four characters
 	JR	BUILD3		;and continue
 BUILD2	LD	A,' '		;just insert spaces
 	LD	(DE),A		;into buffer
 	INC	DE		;point to next
 	DJNZ	BUILD2		;loop til done
 BUILD3	CALL	SETPAT		;set patch for error
 	LD	HL,DIR		;point to DIR cmd
 VECT0	CALL	4405H		;or 4419H for NewDos 80
 	LD	DE,3C40H	;point to filename start
 	LD	HL,(POS)	;get buffer position
 	LD	IX,BUFF		;point to disk name
 BLDLP	LD	A,(DE)		;get a byte
 	CP	' '		;is it a space?
 	JR	NZ,NOSPC	;go if not
 	INC	DE		;else point to next
 	LD	A,D		;check for end of video
 	CP	40H		;end?
 	JR	NZ,BLDLP	;loop til found
 	JP	BUILD		;loop til break
 NOSPC	LD	B,12		;bytes to get from video
 NOSPC1	LD	A,(DE)		;get a byte
 	LD	(HL),A		;move to buffer
 	INC	DE		;point to next
 	INC	HL		;point to next
 	DJNZ	NOSPC1		;loop til copied
 	LD	B,4		;now copy disk name
 	PUSH	IX		;save start
 CPNM	LD	A,(IX)		;get a byte
 	CP	0DH		;end of id?
 	JR	Z,ENDID		;go if yes
 	LD	(HL),A		;else move to buffer
 	INC	HL		;point to next
 	INC	IX		;point to next
 	DJNZ	CPNM		;loop til done
 BLD1	POP	IX		;point to start ID again
 	LD	(POS),HL	;save new position
 	PUSH	HL		;save it for now
 	LD	HL,(ENTRY)	;get number of entries
 	INC	HL		;add 1 to it
 	LD	(ENTRY),HL	;save it again
 	POP	HL		;restore position
 	JP	BLDLP		;loop til all read in
 ENDID	LD	(HL),' '	;fill with spaces
 	INC	HL		;point to next
 	DJNZ	ENDID		;loop til done
 	JR	BLD1		;loop back now
 VIEW	LD	A,(ENTRY)	;get number of entries
 	OR	A		;test for any
 	JR	NZ,VIEW1	;go if some
 	LD	A,(ENTRY+1)	;else check MSB entry
 	OR	A		;any there?
 	JP	Z,MENU		;go if none
 VIEW1	CALL	01C9H		;clear the video
 	LD	HL,PBUFF	;point to buffer
 	XOR	A		;zero out line counter
 	LD	(LINE),A	;and save it
 VIEW2	LD	B,12		;length of filename
 VIEW3	LD	A,(HL)		;get a byte
 	CALL	33H		;display it
 	INC	HL		;point to next
 	DJNZ	VIEW3		;loop til shown
 	LD	A,'-'		;show minus sign
 	CALL	33H		;show it on video
 	LD	B,4		;lenght of ID block
 VIEW4	LD	A,(HL)		;get ID
 	CALL	33H		;print it
 	INC	HL		;point to next
 	DJNZ	VIEW4		;loop til shown
 	LD	A,0DH		;do a C/R
 	CALL	33H		;display it on video
 	LD	A,(LINE)	;get lines
 	INC	A		;add one to it
 	CP	0FH		;have 15 lines?
 	JR	NZ,NOTYET	;go if not yet
 	CALL	49H		;wait for any key
 	CP	01H		;look for BREAK key
 	JP	Z,MENU		;exit if pressed
 	XOR	A		;remove line counter
 NOTYET	LD	(LINE),A	;save value
 	LD	A,(HL)		;get next byte
 	CP	00H		;end of file?
 	JR	NZ,VIEW2	;loop til done
 VIEWA	CALL	49H		;else wait for inkey
 	CP	' '		;don't go if space bar
 	JR	Z,VIEWA		;loop til another key
 	JP	MENU		;and back to menu
 PRINT	LD	HL,PRTCON	;point to control codes
 	LD	A,(HL)		;get a byte
 	CP	'.'		;. = no codes
 	JR	Z,NONE		;go if none
 	LD	B,40		;else there are some
 	PUSH	HL		;save pointer
 	LD	HL,CODE1	;buffer to zero out
 CLRBUF	LD	(HL),00H	;zero out buffers
 	INC	HL		;point to next
 	DJNZ	CLRBUF		;buffers are 0's
 	POP	HL		;HL=prtcon again
 	LD	B,40		;reset bytes to read
 	LD	DE,CODE1	;point to ON info
 CON	LD	A,(HL)		;get a byte
 	CP	0DH		;end of line?
 	JR	Z,CON1A		;go if all done
 	CP	'/'		;else is it delimiter?
 	JR	Z,CON2		;go if yes
 	CP	'0'		;look for Numbers
 	JR	C,RANGE		;go if too low
 	CP	':'		;else check high side
 	JR	NC,RANGE	;go if too high
 	LD	(DE),A		;else store in buffer
 	INC	DE		;point to next
 RANGE	INC	HL		;point to next char
 	DJNZ	CON		;loop for 40
 	JR	CON1A		;go figure them out
 CON2	LD	DE,CODE2	;point to OFF info
 	JR	RANGE		;and continue
 CON1A	LD	IX,CODE1	;point to ON info
 	PUSH	IX		;make IY=IX
 	POP	IY		;same now
 	CALL	CON4		;convert to DIGITS
 	LD	IX,CODE2	;point to OFF set
 	PUSH	IX		;make IY=IX
 	POP	IY		;now
 	CALL	CON4		;convert to DIGITS
 	JR	CON6		;and continue
 CON4	LD	A,(IX)		;get a byte
 	OR	A		;look for a 0
 	JR	Z,CON5		;go if conversion done
 	SUB	30H		;else make digit 0-9
 	OR	A		;test for a 0
 	JR	Z,PASS		;bypass add if 0
 	LD	B,A		;else move value to loop
 	LD	HL,0000H	;reset main counter
 	LD	DE,10		;multiply by 10's
 ADDIT	ADD	HL,DE		;do it
 	DJNZ	ADDIT		;loop til added
 PASS	INC	IX		;point to next digit
 	LD	A,(IX)		;get it
 	SUB	30H		;make it 0-9
 	OR	A		;test for zero
 	JR	Z,PASS1		;bypass add if zero
 	LD	B,A		;else move to loop
 ADDIT1	INC	HL		;add to value by 1's
 	DJNZ	ADDIT1		;loop til done
 PASS1	LD	(IY+00H),L	;store LSB (0-255) code
 	INC	IY		;point to next
 	INC	IX		;and again
 	JR	CON4		;continue til end
 CON5	LD	(IY+00H),00H	;store a zero
 	RET			;back to caller
 CON6	LD	A,1		;set code flag
 	JR	SETFLG		;and do it
 NONE	XOR	A		;zero out print flag
 SETFLG	LD	(PFLAG),A	;save status
 	LD	HL,QUEST1	;point to prompt
 	CALL	DISPLY		;show it
 	LD	A,(COLUMN)	;get printer columns
 	SUB	30H		;make it 1-9
 	LD	(PRTCOL),A	;and save for printer
 	LD	HL,0001H	;reset page number
 	LD	(PNUM),HL	;save it for now
 	LD	HL,PBUFF	;point to program buffer
 	LD	A,(HL)		;get a byte
 	CP	00H		;and in memory?
 	JP	Z,MENU		;back if not
 HEAD	PUSH	HL		;save text pointer
 	LD	A,07H		;reset to 7th line
 	LD	(LINE),A	;save it
 	LD	A,' '
 	CALL	3BH
 	LD	A,0DH		;get a C/R
 	CALL	3BH		;LPRINT it
 	LD	B,80		;set number of characters
 HEAD1	LD	A,'-'		;character to print
 	CALL	3BH		;LPRINT it
 	DJNZ	HEAD1		;loop til done
 	LD	A,0DH		;do a C/R
 	CALL	3BH		;LPRINT it
 	LD	HL,DATE		;point to date
 	CALL	4470H		;get it
 	LD	HL,(PNUM)	;get page number
 	LD	DE,PAGE		;point to buffer
 	CALL	MATH		;calculate it
 	LD	HL,(PNUM)	;get last page number
 	INC	HL		;add 1 to it
 	LD	(PNUM),HL	;save it again
 	LD	HL,TITLE	;point to title
 HEAD2	LD	A,(HL)		;get character
 	CALL	3BH		;LPRINT it
 	CP	0DH		;was it a C/R
 	JR	Z,HEAD3		;go if yes
 	INC	HL		;else point to next
 	JR	HEAD2		;loop til C/R
 HEAD3	LD	B,80		;bytes to LPRINT
 HEAD4	LD	A,'-'		;character to print
 	CALL	3BH		;lprint it
 	DJNZ	HEAD4		;loop til done
 	LD	A,' '
 	CALL	3BH
 	LD	A,0DH		;do a C/R
 	CALL	3BH		;LPRINT it
 	LD	A,' '
 	CALL	3BH
 	LD	A,0DH		;do another
 	CALL	3BH		;LPRINT it
 	POP	HL		;point to filenames
 MAR	LD	A,(MARGIN)	;get indent
 	LD	B,A		;move to loop
 MAR1	LD	A,' '		;space in
 	CALL	3BH		;LPRINT it
 	DJNZ	MAR1		;loop til done
 	LD	A,(PFLAG)	;test for CODES
 	OR	A		;0=none 1=yes
 	JR	Z,PRINT2	;continue if none
 	PUSH	HL		;else save pointer
 	LD	HL,CODE1	;point to ON codes
 	CALL	SENDCD		;send codes to printer
 	POP	HL		;restore the pointer
 PRINT2	LD	B,12		;length of filename
 PRINT3	LD	A,(HL)		;get a byte
 	OR	A		;test for zero
 	JR	Z,PRINT6	;go if done
 	CALL	3BH		;LPRINT it
 	LD	A,(3840H)	;do a keyboard scan
 	CP	04H		;look for break key
 	JR	Z,PRINT6	;leave if pressed
 	INC	HL		;point to next
 	DJNZ	PRINT3		;loop for filename
 	LD	A,'-'		;load a minus
 	CALL	3BH		;LPRINT it
 	LD	B,4		;bytes to print
 PRINT5	LD	A,(HL)		;get a byte
 	CALL	3BH		;LPRINT it
 	INC	HL		;point to next
 	DJNZ	PRINT5		;loop til done
 	LD	A,(PRTCOL)	;get columns printed
 	DEC	A		;look for zero
 	JR	Z,LFEED		;go if end of line
 	LD	(PRTCOL),A	;else save value
 	LD	A,' '		;get 1 space
 	CALL	3BH		;LPRINT it
 	LD	A,' '		;and do it again
 	CALL	3BH		;LPRINT it
 	JR	PRINT2		;loop til done
 PRINT6	LD	A,(PFLAG)	;test for codes
 	OR	A		;0=none on
 	JR	Z,PRINT7	;continue then
 	LD	HL,CODE2	;else point to OFF codes
 	CALL	SENDCD		;turn off mode
 PRINT7	LD	A,0DH		;else do a C/R
 	CALL	3BH		;LPRINT it
 	JP	MENU		;and back to menu
 LFEED	LD	A,(PFLAG)	;test for printer codes
 	OR	A		;0=none 1=yes
 	JR	Z,LFEED0	;go if none
 	PUSH	HL		;else save pointer
 	LD	HL,CODE2	;point to OFF set
 	CALL	SENDCD		;and send them
 	POP	HL		;restore pointer
 LFEED0	LD	A,0DH		;get a C/R
 	CALL	3BH		;LPRINT it
 	LD	A,(COLUMN)	;get columns wanted
 	SUB	30H		;make it 1-9
 	LD	(PRTCOL),A	;reset our value
 	LD	A,(LINE)	;get lines on page
 	INC	A		;add 1 to it
 	CP	66		;maximum yet
 	JR	Z,FORMFD	;yes then step up
 LFEED1	LD	(LINE),A	;else save new value
 	JP	MAR		;and redo margin (cont)
 FORMFD	LD	A,(LINE)	;get lines printed
 	LD	B,A		;move for subtract
 	LD	A,67		;to top of next page
 	SBC	A,B		;find steps
 	LD	B,A		;move to loop
 FORM	LD	A,' '
 	CALL	3BH
 	LD	A,0DH		;get a C/R
 	CALL	3BH		;LPRINT it
 	DJNZ	FORM		;loop til next page
 	JP	HEAD		;and redo heading
 SENDCD	LD	A,(HL)		;get a byte
 	OR	A		;0=end of codes
 	RET	Z		;back if done
 	CALL	3BH		;else LPRINT it
 	INC	HL		;point to next
 	JR	SENDCD		;loop til done
 SORT	LD	HL,PBUFF	;point to buffer
 	LD	A,(HL)		;check for file
 	OR	A		;0=none
 	JP	Z,MENU		;back if none
 	LD	HL,QUESTA	;point to question
 	CALL	DISPLY		;show it
 SLP	CALL	49H		;wait for inkey
 	AND	5FH		;convert to UPPER
 	CALL	33H		;print input
 	CP	'D'		;sort by DISK?
 	JP	Z,SORTD		;go if yes
 	CP	'N'		;else by Name?
 	JR	Z,SORTA		;go if yes
 	LD	A,08H		;else erase it
 	CALL	33H		;back it up
 	JR	SLP		;loop for valid
 SORTA	LD	HL,PBUFF	;point to buffer
 	PUSH	HL		;save pointer
 	LD	HL,MSG		;point to message
 	CALL	DISPLY		;show it
 	POP	HL		;and continue
 	LD	DE,16		;offset to next filename
 	PUSH	HL		;save first name
 	ADD	HL,DE		;find second one
 	PUSH	HL		;move the address
 	POP	DE		;into DE for compares
 	POP	HL		;HL=first, DE=second now
 SORT0	LD	A,(DE)		;test for DE=end of file
 	OR	A		;0=top reached
 	JP	Z,ATTOP		;go if all the way
 	PUSH	DE		;else save second add.
 	PUSH	HL		;save first address
 	LD	B,12		;bytes to compare
 SORT1	LD	A,(DE)		;get a second byte
 	CP	(HL)		;check byte for byte
 	JR	Z,SORT5		;next if equal
 	JR	C,DOSWAP	;go if 2nd<1st
 	JR	SORT3		;else skip to next
 SORT5	INC	HL		;else point to next
 	INC	DE		;and here too
 	DJNZ	SORT1		;loop for 12 char.
 SORT4	LD	B,4		;bytes to step past
 SORT2	INC	DE		;step past 4 char ID
 	DJNZ	SORT2		;loop til done
 	POP	HL		;HL=1st name
 	POP	IY		;dummy. Leave DE alone
 	JR	SORT0		;step DE to top memory
 ATTOP	LD	DE,16		;offset value
 	ADD	HL,DE		;find next filename
 	PUSH	HL		;save it
 	ADD	HL,DE		;find 1 above that
 	PUSH	HL		;move second 1 to DE
 	POP	DE		;DE=second filename
 	POP	HL		;HL=first filename
 	LD	A,(HL)		;test for HL=top
 	OR	A		;0=top done
 	JP	Z,MENU		;back if done
 	JR	SORT0		;else back to routine
 SORT3	INC	DE		;point to next
 	DJNZ	SORT3		;step to ID of second
 	JR	SORT4		;and then past ID
 DOSWAP	POP	HL		;point back to first
 	POP	DE		;point to one to switch
 	PUSH	HL		;save first one for later
 	LD	B,16		;bytes to copy
 SWAP1	LD	A,(HL)		;get 1 from first
 	PUSH	AF		;save it on stack
 	LD	A,(DE)		;get 1 from second
 	LD	(HL),A		;move it to first
 	POP	AF		;get back first one
 	LD	(DE),A		;move to second one
 	INC	DE		;point to next
 	INC	HL		;point to next
 	CALL	BLINK		;show something
 	DJNZ	SWAP1		;loop for 16
 	POP	HL		;point to start of first
 	JR	SORT0		;and back to sort
 SORTD	LD	HL,PBUFF	;point to buffer
 	LD	DE,16		;offset to next
 	PUSH	HL		;save address
 	ADD	HL,DE		;find next 1
 	PUSH	HL		;move it to DE
 	POP	DE		;now
 	POP	HL		;HL=1 DE=2
 S0	LD	A,(DE)		;get a byte
 	OR	A		;0=top reached
 	JR	Z,ATTOP1	;go if there
 	PUSH	DE		;else save DE+HL
 	PUSH	HL		;save it
 	LD	B,12		;bytes to step ahead
 STEPA	INC	DE		;point to next
 	INC	HL		;same (to ID)
 	DJNZ	STEPA		;loop til file ID
 	LD	B,4		;bytes to check
 S1	LD	A,(DE)		;get a byte
 	CP	(HL)		;compare
 	JR	Z,S5		;go if same
 	JR	C,CHANGE	;go if greater
 	JR	S3		;else its less
 S5	INC	HL		;point to next
 	INC	DE		;"	"
 	DJNZ	S1		;loop for 4
 S4	POP	HL		;HL=start again
 	POP	IY		;leave DE alone
 	JR	S0		;continue now
 ATTOP1	LD	DE,16		;offset to next
 	ADD	HL,DE		;find it
 	PUSH	HL		;save it
 	ADD	HL,DE		;find 1 above it
 	PUSH	HL		;move it to
 	POP	DE		;DE
 	POP	HL		;HL=first
 	LD	A,(HL)		;get a byte
 	OR	A		;0=done
 	JP	Z,MENU		;back if done
 	JR	S0		;else loop back
 S3	INC	DE		;step through ID
 	DJNZ	S3		;til done
 	JR	S4		;then back
 CHANGE	POP	HL		;hl = first
 	POP	DE		;DE=second
 	PUSH	HL		;save address
 	LD	B,16		;bytes to move
 CH1	LD	A,(HL)		;get a byte
 	PUSH	AF		;save it
 	LD	A,(DE)		;get second 1
 	LD	(HL),A		;move it
 	POP	AF		;get back first
 	LD	(DE),A		;move it
 	INC	DE		;point to next
 	INC	HL		;point to next
 	CALL	BLINK		;blink a *
 	DJNZ	CH1		;loop for 16
 	POP	HL		;hl=start again
 	JP	S0		;loop til done
 WRITE	LD	HL,PBUFF	;point to buffer
 	LD	A,(HL)		;get a byte
 	OR	A		;any file?
 	JP	Z,MENU		;back if not
 	LD	HL,QUEST2	;point to filespec?
 	CALL	DISPLY		;show it
 	LD	HL,BUFF		;point to buffer
 	LD	B,20		;maximum input length
 	CALL	40H		;wait for input
 	JP	C,MENU		;menu if BREAK
 	LD	A,B		;test for any input
 	OR	A		;0=just enter
 	JP	Z,MENU		;menu if no filespec
 	LD	HL,DUMMY	;point to I/O buffer
 	LD	DE,BUFF		;point to filespec
 	LD	B,00H		;set LRL=256
 	CALL	4420H		;re-open or create
 	JP	NZ,ERROR	;go if disk I/O error
 	LD	HL,PBUFF	;else point to buffer
 WRITE1	LD	DE,BUFF		;point to filespec
 	LD	A,(HL)		;test for end of list
 	OR	A		;test for end of list
 	JR	Z,EOW		;go if done
 	CALL	1BH		;else write byte to disk
 	JP	NZ,ERROR	;go if error
 	CALL	BLINK		;blink a *
 	INC	HL		;point to next
 	JR	WRITE1		;loop til done
 EOW	CALL	1BH		;write 0 to disk (eof)
 	LD	DE,BUFF		;point to filespec
 	CALL	4428H		;close the file
 	JP	Z,MENU		;go if done
 ERROR	SET	7,A		;set for return
 	RES	6,A		;set enlarged msg
 	CALL	4409H		;display error
 	CALL	49H		;wait for key
 	JP	MENU		;and back to menu
 LOAD	LD	HL,QUEST3	;point to prompt
 	CALL	DISPLY		;show it
 	LD	HL,BUFF		;point to buffer
 	LD	B,20		;max input
 	CALL	40H		;wait for input
 	JP	C,MENU		;back if BREAK
 	LD	A,B		;else test for entry
 	OR	A		;anything?
 	JP	Z,MENU		;back if not
 	LD	HL,0000H	;zero out entries
 	LD	(ENTRY),HL	;and save it
 	LD	DE,BUFF		;else point to name
 	LD	HL,DUMMY	;point to I/O block
 	LD	B,00H		;set LRL=256
 	CALL	4424H		;OPEN not CREATE
 	JP	NZ,ERROR	;go if not there
 	LD	HL,PBUFF	;point to buffer
 LOAD0	LD	B,16		;bytes per filename
 LOAD1	LD	DE,BUFF		;point to filespec
 	CALL	13H		;read a byte
 	JP	NZ,ERROR	;go if error
 	LD	(HL),A		;else load in a byte
 	CP	00H		;end of read
 	JR	Z,LOAD2		;go close if yes
 	INC	HL		;else point to next
 	CALL	BLINK		;blink a splat
 	DJNZ	LOAD1		;loop for length
 	PUSH	HL		;save pointer
 	LD	HL,(ENTRY)	;get number of files
 	INC	HL		;add one to it
 	LD	(ENTRY),HL	;save it
 	POP	HL		;point to buffer again
 	JR	LOAD0		;loop til done
 LOAD2	LD	(POS),HL	;save start of next entry
 	JP	MENU		;back to menu
 KILL	LD	HL,QUEST4	;point to prompt
 	CALL	DISPLY		;show it
 	LD	HL,BUFF		;point to buffer
 	LD	B,20		;max input
 	CALL	40H		;wait for input
 	JP	C,MENU		;back if BREAK
 	LD	A,B		;else test for enter
 	OR	A		;anything?
 	JP	Z,MENU		;back if no input
 	LD	DE,BUFF		;else point to file
 	LD	HL,DUMMY	;point to I/O block
 	LD	B,00H		;set LRL=256
 	CALL	4424H		;OPEN only
 	JP	NZ,ERROR	;go if not there
 	LD	DE,BUFF		;else we can kill it
 	CALL	442CH		;kill the file now
 	JP	NZ,ERROR	;go if disk error
 	JP	MENU		;else back to menu
 SHODIR	LD	(DIRNM),A	;store in directory cmd
 	CALL	SETPAT		;set error patch
 	LD	HL,DIR		;point to command
 VECT1	CALL	4405H		;use 4419H for NewDos
 	LD	A,(DIRSYS)	;get normal drive#
 	LD	(DIRNM),A	;store it
 	LD	HL,QUEST5	;point to prompt
 	CALL	DISPLY		;show it
 	CALL	49H		;wait for a key
 	JP	RESPAT		;and reset patch
 CONFIG	CALL	01C9H		;clear the video
 	CALL	DOSSYS		;find dos system
 	CALL	DOSDIR		;get default drive
 	LD	HL,MENU3	;point to menu
 	CALL	DISPLY		;show it
 CON1	CALL	49H		;wait for any key
 	AND	5FH		;convert to UPPER case
 	CP	'S'		;change System type?
 	JR	Z,DOSCHN	;go if yes
 	CP	'E'		;exit?
 	JP	Z,MENU		;back to main menu
 	CP	'W'		;write configuration?
 	JP	Z,WRCON		;go if yes
 	CP	'D'		;reset default drive?
 	JR	Z,DRCHN		;go if yes
 	CP	'P'		;else input new codes?
 	JP	Z,SETPRT	;go if yes
 	CP	'C'		;change printer columns
 	JP	Z,CHNCOL	;go if yes
 	JR	CON1		;else back to menu
 DOSCHN	LD	A,(SYS)		;get dos now
 	OR	A		;test for 0 (Dos+)
 	JR	NZ,MAKE0	;go if zero
 	INC	A		;else make it 1
 DOS0	LD	(SYS),A		;and save answer
 	JR	CONFIG		;and redo display
 MAKE0	DEC	A		;make it zero
 	JR	DOS0		;and redo display
 DRCHN	LD	HL,QUEST7	;point to question
 	CALL	DISPLY		;show it
 DIRCHN	CALL	49H		;wait for a number
 	CP	01H		;or BREAK
 	JR	Z,CONFIG	;back on break
 	CP	'0'		;look for low limit
 	JR	C,DIRCHN	;bak if too low
 	CP	'4'		;else too high
 	JR	NC,DIRCHN	;back if yes
 	LD	(DIRDVR),A	;else store new drive
 	LD	(DIRSYS),A	;and save in config
 	JR	CONFIG		;redo dislay
 CHNCOL	LD	HL,QUEST8	;point to prompt
 	CALL	DISPLY		;show it
 COL1	CALL	49H		;wait for a key
 	CP	01H		;break?
 	JR	Z,CONFIG	;back if yes
 	CP	'0'		;else low limit
 	JR	C,COL1		;back if too low
 	CP	':'		;else greater than 9?
 	JR	NC,COL1		;back if yes
 	LD	(COLUMN),A	;else replace value
 	JP	CONFIG		;and back to config
 DOSDIR	LD	A,(DIRSYS)	;get directory #
 	LD	(DIRDVR),A	;move it
 	LD	(DIRNM),A	;replace drive for DIR
 	LD	(DIRSEL),A	;move to ASCII
 	LD	A,(COLUMN)	;get number of columns
 	LD	(LPCOL),A	;move to config area
 	RET			;back to caller
 DOSSYS	LD	A,(SYS)		;get DOS type
 	OR	A		;test for zero
 	JR	NZ,D2		;go if type 2
 	LD	HL,DIR1		;point to CAT cmd
 	CALL	MVDIR		;move command
 	LD	HL,4405H	;make vector DOS+
 	CALL	REVECT		;reset vectors
 	LD	HL,DOSONE	;point to DOS+ name
 	JR	MVNM		;and move it
 D2	LD	HL,DIR2		;point to DIR name
 	CALL	MVDIR		;move command
 	LD	HL,4419H	;reset address
 	CALL	REVECT		;reset vectors
 	LD	HL,DOSTWO	;point to NewDos
 MVNM	LD	DE,DTYPE	;point to buffer
 	LD	B,11		;characters to move
 	LD	IX,TITLE	;point to Title
 MVNM1	LD	A,(HL)		;get a byte
 	LD	(DE),A		;transfer it
 	LD	(IX),A		;store in title too
 	INC	IX		;point to next
 	INC	DE		;point to next
 	INC	HL		;and here too
 	DJNZ	MVNM1		;loop til moved
 	RET			;back to caller
 MVDIR	LD	DE,DIR		;point to cmd
 	LD	B,5		;bytes to move
 MVDIR1	LD	A,(HL)		;get a byte
 	LD	(DE),A		;move it
 	INC	HL		;point to next
 	INC	DE		;and here too
 	DJNZ	MVDIR1		;loop til copied
 	RET			;back to caller
 REVECT	LD	(VECT0+1),HL	;reset vector
 	LD	(VECT1+1),HL	;and another
 	RET			;back to caller
 SETPRT	LD	HL,QUEST9	;point to prompt
 	CALL	DISPLY		;show it
 	LD	HL,BUFF		;point to buffer
 	LD	B,40		;max input
 	CALL	40H		;go get input
 	JP	C,MENU		;go if BREAK
 	LD	A,B		;test for input
 	OR	A		;0=none
 	JP	Z,MENU		;back if none
 	LD	HL,PRTCON	;point to buffer
 	LD	IX,BUFF		;point to buffer
 	LD	B,40		;bytes to move
 SET1	LD	A,(IX)		;get a byte
 	LD	(HL),A		;store in buffer
 	CP	0DH		;end of line
 	JR	Z,SET2		;go if yes
 	INC	HL		;point to next
 	INC	IX		;point to next
 	DJNZ	SET1		;else loop til done
 SET3	JP	CONFIG		;and redisplay it
 SET2	DEC	B		;minus another
 SET4	INC	HL		;point to next
 	LD	(HL),' '	;space out the rest
 	DJNZ	SET4		;loop til done
 	JR	SET3		;and redo display
 WRCON	LD	HL,QUEST6	;point to drive#
 	CALL	DISPLY		;show it
 WRCON1	CALL	49H		;wait for a number
 	CP	'0'		;look
 	JR	C,WRCON1	;back if too low
 	CP	'4'		;check high limit
 	JR	NC,WRCON1	;back if too high
 	LD	(CONDV),A	;store drive
 	CALL	33H		;display it on video
 	LD	HL,CONFL	;point to filename
 	LD	IX,BUFF		;where to move it to
 	LD	B,13		;bytes to move
 WRCON2	LD	A,(HL)		;get a byte
 	LD	(IX),A		;move it
 	INC	HL		;point to next
 	INC	IX		;point to next
 	DJNZ	WRCON2		;loop til moved
 	LD	HL,DUMMY	;point to I/O block
 	LD	DE,BUFF		;point to filespec
 	LD	B,00H		;make LRL=256
 	CALL	4420H		;open or create
 	JP	NZ,ERROR	;go if error
 	LD	DE,BUFF		;point to buffer
 	LD	A,(SYS)		;get system type
 	CALL	1BH		;write it to disk
 	JP	NZ,ERROR	;go if error
 	LD	DE,BUFF		;point to filename
 	LD	A,(DIRSYS)	;get directory
 	CALL	1BH		;write it out
 	JP	NZ,ERROR	;go if error
 	LD	DE,BUFF		;point to filespec
 	LD	A,(COLUMN)	;get columns
 	CALL	1BH		;write it to disk
 	JP	NZ,ERROR	;go if disk error
 	LD	HL,PRTCON	;point to printer codes
 	LD	B,40		;bytes to write
 WRCON3	LD	DE,BUFF		;point to file
 	LD	A,(HL)		;get a byte
 	CALL	1BH		;write it to disk
 	JP	NZ,ERROR	;go if error
 	INC	HL		;point to next
 	DJNZ	WRCON3		;loop til done
 	LD	DE,BUFF		;point to buffer
 	CALL	4428H		;close the file
 	JP	MENU		;and back to menu
 RDCON	LD	HL,CONFL	;point to filespec
 	LD	DE,BUFF		;point to buffer
 	PUSH	DE		;save the start
 RECON1	LD	A,(HL)		;get a byte
 	CP	':'		;end of filename?
 	JR	Z,RECON2	;go if yes
 	LD	(DE),A		;else move it
 	INC	DE		;point to next
 	INC	HL		;point to next
 	JR	RECON1		;loop til : found
 RECON2	LD	A,0DH		;insert a C/R
 	LD	(DE),A		;store in the buffer
 	POP	DE		;DE=filespec
 	LD	HL,DUMMY	;point to I/O block
 	LD	B,00H		;set LRL=265
 	CALL	4424H		;open not create
 	JR	NZ,RECON5	;go if not found
 	LD	HL,PRTCON	;point to buffer
 	LD	B,40		;bytes to load in
 RECON3	LD	DE,BUFF		;point to filespec
 	CALL	13H		;read 1 byte
 	JP	NZ,ERROR	;go if error
 	LD	(SYS),A		;store for system
 	LD	DE,BUFF		;point to buffer
 	CALL	13H		;read in DIR
 	JP	NZ,ERROR	;go if error
 	LD	(DIRSYS),A	;store in memory
 	LD	DE,BUFF		;point to filespec
 	CALL	13H		;read in Columns
 	JP	NZ,ERROR	;go if error
 	LD	(COLUMN),A	;else store columns
 RECON4	LD	DE,BUFF		;point to buffer
 	CALL	13H		;read a byte
 	JP	NZ,ERROR	;go if error
 	LD	(HL),A		;store in buffer
 	INC	HL		;point to next
 	DJNZ	RECON4		;loop til read
 	RET			;back to caller
 RECON5	POP	HL		;remove return address
 	JP	CONFIG		;and configure system
 BLINK	LD	A,(3C3EH)	;get a byte
 	XOR	0AH		;toggle a *
 	LD	(3C3EH),A	;and put it back
 	RET			;back to caller
 SETPAT	LD	HL,DIRERR	;point to resume routine
 	LD	(4031H),HL	;store for DIR or CAT cmd
 	RET			;back to caller
 RESPAT	LD	HL,(VECT2)	;get normal address
 	LD	(4031H),HL	;put it back
 	JP	MENU		;back to menu
 DIRERR	CALL	01C9H		;clear the video
 	LD	A,(DIRNM)	;get directory drive
 	LD	(ERDRV),A	;move to error display
 	CALL	DOSDIR		;reset directory number
 	LD	HL,ERRMSG	;point to error msg
 	CALL	DISPLY		;show it on video
 	CALL	49H		;wait for inkey
 	JR	RESPAT		;reset patch and return
 DISPLY	LD	A,(HL)		;get a byte
 	CP	03H		;end of print?
 	RET	Z		;back if yes
 	CALL	33H		;else show it
 	INC	HL		;point to next
 	JR	DISPLY		;loop til shown
 CHKDUP	LD	A,(ENTRY)	;check for any entries
 	OR	A		;any LSB entry?
 	JR	NZ,DUP		;go if there are some
 	LD	A,(ENTRY+1)	;else check MSB
 	OR	A		;and here?
 	RET	Z		;back if not
 DUP	LD	HL,PBUFF	;else we have some
 DUP1	LD	IX,BUFF		;point to buffer
 	LD	DE,12		;bytes to ID name
 	PUSH	HL		;save position
 	ADD	HL,DE		;point to ID name
 	LD	B,4		;maximum to check
 CHKENT	LD	A,(IX)		;get buffer byte
 	CP	0DH		;end of buffer input?
 	JR	NZ,NOTEND	;go if no C/R yet
 	LD	A,' '		;else check for space
 	CP	(HL)		;in file ID block
 	JR	NZ,DIFF		;go if different
 STEP	INC	HL		;point to next
 	DJNZ	STEP		;step to end of filename
 	JR	CHK1		;and continue
 NOTEND	LD	A,(HL)		;get file ID
 	CP	(IX)		;check against buffer
 	JR	NZ,DIFF		;go if not same
 	INC	HL		;else same point to next
 	INC	IX		;and in buffer
 	DJNZ	CHKENT		;loop for 4 characters
 CHK1	PUSH	HL		;HL=start next filename
 	POP	DE		;DE=Next filename
 	POP	HL		;HL=First filename
 	PUSH	HL		;save address for later
 DELETE	LD	A,(DE)		;move file down now
 	LD	(HL),A		;replace first name
 	CP	00H		;end of file?
 	JR	Z,ENDDEL	;go if yes
 	INC	HL		;else point to next
 	INC	DE		;"		"
 	JR	DELETE		;loop til end of file
 ENDDEL	LD	(POS),HL	;save starting position
 	LD	B,16H		;remove last filename
 DEL1	LD	(HL),00H	;zero it out
 	INC	HL		;point to next
 	DJNZ	DEL1		;loop til gone
 	LD	HL,(ENTRY)	;get number of entires
 	DEC	HL		;minus 1 from it
 	LD	(ENTRY),HL	;store the new total
 	POP	HL		;address to resume search
 	JR	DUP1		;and continue til end
 DIFF	POP	HL		;point to start filename
 	LD	DE,16		;offset to next
 	ADD	HL,DE		;find next filename
 	LD	A,(HL)		;get a byte
 	CP	00H		;end of file?
 	RET	Z		;back if yes
 	JP	DUP1		;else continue
 MATH	LD	BC,-10000	;count 10000
 	CALL	BINSUB		;do it
 	LD	BC,-1000	;count 1000
 	CALL	BINSUB		;do it
 	LD	BC,-100		;count 100
 	CALL	BINSUB		;do it
 	LD	BC,-10		;count 10
 	CALL	BINSUB		;do it
 	LD	BC,-1		;count units
 	CALL	BINSUB		;do it
 	RET			;back to caller
 BINSUB	LD	A,0FFH		;set to -1
 BSUB	INC	A		;add 1
 	ADD	HL,BC		;add with subtract
 	JR	C,BSUB		;loop til too small
 	OR	A		;clear the carry flag
 	SBC	HL,BC		;1 number back
 	ADD	A,30H		;convert to ASCII
 	LD	(DE),A		;store in buffer
 	INC	DE		;point to next
 	RET			;back to caller
 DISKNM	DEFB	0DH
 	DEFM	'Name to give this DISK >'
 	DEFB	0EH
 	DEFB	03H
 DIR1	DEFM	'CAT :'
 DIR2	DEFM	'DIR :'
 DIR	DEFM	'.....'
 DIRNM	DEFM	'1'		;default to drive 1
 	DEFB	0DH		;terminator
 MENU1	DEFM	'               Master Disk Index   Version 2.0'
 	DEFB	0DH
 	DEFM	'                   <c> 1983 by Mel Patrick'
 	DEFW	0D0DH
 	DEFM	'--------------------------------------------------------------'
 	DEFB	0DH
 	DEFM	'Maximum Entry :'
 MAXBUF	DEFM	'.....'
 	DEFM	'    Programs :'
 ENTBUF	DEFM	'.....'
 	DEFM	'    File Length:'
 MEMBUF	DEFM	'.....'
 	DEFB	0DH
 	DEFM	'--------------------------------------------------------------'
 	DEFW	0D0DH
 	DEFM	'<B>uild a Index                  <W>rite Index to Disk'
 	DEFB	0DH
 	DEFM	'<V>iew File on Video             <L>oad Index from Disk'
 	DEFB	0DH
 	DEFM	'<P>rint file on Line Printer     <K>ill File on Disk'
 	DEFB	0DH
 	DEFM	'<S>ort Index Alphabetically      <E>xit to Dos Ready'
 	DEFB	0DH
 	DEFM	'<#> Directory of Drive (0-3)     <C>onfigure System'
 	DEFW	0D0DH
 	DEFM	'Selection :'
 	DEFB	03H
 MENU2	DEFM	'----------------==== Build Index File ===------------------'
 	DEFW	0D0DH
 	DEFM	'Insert disk into Drive :'
 DIRSEL	DEFM	'1'
 	DEFM	', enter up to a 4 digit'
 	DEFB	0DH
 	DEFM	'alpha-numeric code to represent that disk and press the'
 	DEFB	0DH
 	DEFM	'<ENTER> key to read and add to Index Directory.'
 	DEFB	0DH
 	DEFM	'To exit, press the <BREAK> key.'
 	DEFW	0D0DH
 	DEFM	'Last Disk Name Used> '
 IDBLK	DEFM	'....'
 	DEFB	0DH
 	DEFB	03H
 MENU3	DEFM	' ----------------- Master Index Configuration ----------------'
 	DEFW	0D0DH
 	DEFM	'<W>rite Configuration            <S>ystem Type :'
 DTYPE	DEFM	'           '
 	DEFB	0DH
 	DEFM	'<E>xit to Menu                   <D>irectory Drive :'
 DIRDVR	DEFM	'1'
 	DEFW	0D0DH
 	DEFM	'<C>olumns on Printer :'
 LPCOL	DEFM	'4'
 	DEFB	0DH
 	DEFM	'<P>reset Printer Codes>'
 PRTCON	DEFM	'........................................'
 	DEFW	0D0DH
 	DEFM	'Selection :'
 	DEFB	03H
 DOSONE	DEFM	'DosPlus 3.4'
 DOSTWO	DEFM	'NewDos 80  '
 CONFL	DEFM	'Mindex/con:'
 CONDV	DEFM	'1'
 	DEFB	0DH
 	DEFB	03H
 QUEST1	DEFB	0DH
 	DEFM	'Printing..'
 	DEFB	03H
 	DEFB	03H
 QUEST2	DEFB	0DH
 	DEFM	'Filename for SAVE: '
 	DEFB	03H
 QUEST3	DEFB	0DH
 	DEFM	'Filename to LOAD: '
 	DEFB	03H
 QUEST4	DEFB	0DH
 	DEFM	'Filename to KILL: '
 	DEFB	03H
 QUEST5	DEFM	'        ---------> Press any key for menu <----------'
 	DEFB	03H
 QUEST6	DEFB	0DH
 	DEFM	'Drive to Save file on :'
 	DEFB	03H
 QUEST7	DEFB	0DH
 	DEFM	'New Directory Drive#'
 	DEFB	03H
 QUEST8	DEFB	0DH
 	DEFM	'New Column Value (1-9) :'
 	DEFB	03H
 QUEST9	DEFB	0DH
 	DEFM	'Enter Printer Codes (ON / OFF)
 	DEFB	0DH
 	DEFB	0EH		;turn on cursor
 	DEFB	03H
 QUESTA	DEFM	'-->Sort by <D>isk or <N>ame : '
 	DEFB	03H
 MSG	DEFB	0DH
 	DEFM	'Sorting File..'
 	DEFB	03H
 ERRMSG	DEFB	23		;switch to 32 cpl
 	DEFW	0D0DH
 	DEFW	0D0DH
 	DEFW	0D0DH
 	DEFM	'* Unable to Read Directory *'
 	DEFW	0D0DH
 	DEFM	'Check Disk Drive <'
 ERDRV	DEFM	'.'
 	DEFM	'> for '
 	DEFB	0DH
 	DEFM	'availability. Use <C>onfig'
 	DEFB	0DH
 	DEFM	'to change if necessary.'
 	DEFB	03H
 TITLE	DEFM	'              '
 DATE	DEFM	'        '
 	DEFM	'   '
 	DEFM	'    Master Program Index Version 2.0     Page '
 PAGE	DEFM	'      '
 	DEFB	0DH
 LINE	DEFB	00H		;line counter
 PFLAG	DEFB	00H		;1=codes, 0=none
 PRTCOL	DEFB	00H		;printing column
 COLUMN	DEFB	00H		;maximum columns
 SYS	DEFB	00H		;Dos 0=DOS+ 1=NewDos80
 DIRSYS	DEFM	'1'		;default drive
 MARGIN	DEFB	05H		;left margin
 MEMSZ	DEFW	0000H		;top of memory avail.
 MAXINP	DEFW	0000H		;max filename to hold
 POS	DEFW	0000H		;next file location
 ENTRY	DEFW	0000H		;number of entires so far
 VECT2	DEFW	0000H		;normal 402EH address
 PNUM	DEFW	0000H		;page number
 CODE1	DEFS	20		;for ON codes
 CODE2	DEFS	20		;for OFF codes
 BUFF	DEFS	50H		;buffer
 DUMMY	DEFS	256		;I/O buffer for DISK
 PBUFF	DEFB	00H		;start of storage
 	END	MINDEX
